/*
 * alloc_bgrotd_conf.c
 * Alloc a BGROTD_CONF struct
 * bgrot project
 * $Fuller: myprograms/bgrot/common/mem/alloc_bgrotd_conf.c,v 1.5 2003/03/23 14:53:37 fullermd Exp $
 */

#include <stdlib.h>

#include <bgrot.h>
#ifdef BGROTD
#include <bgrotd.h>
#endif


/* alloc_bgrotd_conf(): Alloc a BGROTD_CONF struct */
BGROTD_CONF *
alloc_bgrotd_conf(void)
{
	BGROTD_CONF *toret;

	/* Warm up */
	toret = calloc(1, sizeof(BGROTD_CONF));
	if(toret==NULL)
		return(NULL);

	toret->basedir=NULL;
	toret->rundir=NULL;
	toret->listdir=NULL;
	toret->list_index=NULL;
	toret->sel_list=NULL;
	toret->conf_override=NULL;

	toret->sel_list_id=0;
	toret->version=0;

	return(toret);
}
