/*
 * parse_macros.h
 * Macros for use in parse_*() in their various call methods
 * bgrot project
 * $Fuller: myprograms/bgrot/include/parse_macros.h,v 1.11 2003/03/23 14:50:36 fullermd Exp $
 */

#ifndef _PARSE_MACROS_H_
#define _PARSE_MACROS_H_

/* Our free'ing functions vary depending on what file we're in */
#if defined(PARSE_LIST)
#define DO_FREE free_imglist(ilist)
#elif defined(PARSE_INDEX)
#define DO_FREE free_lindex(toret)
#elif defined(PARSE_CONF)
#define DO_FREE free_bgrotd_conf(bgconf)
#endif

/* BAIL() varied depending on where we are */
#if defined(BGROTD)
/* bgrotd usage, internal */
#define BAIL(x) \
		{ \
 			DO_FREE; \
			return(NULL); \
		}

#elif defined(TEST_PROG)
/* *_test usage, standalone */
/* Don't worry about memory leaks, since we're just exiting */
#define BAIL(x) \
		{ \
			fprintf(stderr, x); \
			fprintf(stderr, "\nAt %s::%d\n", __FILE__, __LINE__); \
			exit(1); \
		}
#endif
/* end BAIL() */

/* BAIL_SUB() is used in subroutines that return int's */
#if defined(BGROTD)
#define BAIL_SUB(x)		return(-1);
#elif defined(TEST_PROG)
#define BAIL_SUB(x)		BAIL(x)
#endif

#endif /* !_PARSE_MACROS_H_ */
