/*
 * display_image_thr.c
 * Display one image and exit
 * bgrot project
 * $Fuller: myprograms/bgrot/server/display_image_thr.c,v 1.11 2005/04/12 04:59:26 fullermd Exp $
 */

#include <sys/time.h>
#include <sys/errno.h>
#include <sys/param.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <bgrot.h>
#include <bgrotd.h>


/* Dive in */
void *
display_image_thr(void *imgin)
{
	char thisimg[MAXPATHLEN];
	pid_t fret, wret;

	DEBUG(4, "Top of display_image_thr()");

	/* This is a problem */
	if(imgin==NULL)
	{
		D_PRINTF("Passed in NULL!");
		return(NULL);
	}

	strcpy(thisimg, (char *)imgin);
	free(imgin);

	fret = vfork();

	if(fret==-1)
	{
		/*
		 * We're slightly limited in choices here.  [v]fork() fails
		 * generally because the process limit has been reached.  We're
		 * going to consider it a temporary failure and just return().
		 * Note that this will leave the cur_img pointer screwed up.
		 * Well, tough shit.
		 */
		D_PRINTF("vfork() failed: %s", strerror(errno));
		return(NULL);
	}
	else if(fret>0)
	{
		/* We're the parent */
		DEBUG(4, "Post-vfork() parent");

		sleep(XV_WAIT);
		wret = waitpid(fret, NULL, WNOHANG);
		while(wret != fret)
		{
			/* It's not done yet.  Die, xv, die! */
			D_PRINTF("xv pid %d isn't dead yet!", (int)fret);
			kill(fret, SIGKILL);
			wret = waitpid(fret, NULL, WNOHANG);
			sleep(1);
		}
		return(NULL);
	}
	else
	{
		/* We're the child */
		DEBUG(4, "Post-vfork() child");

		/* Use execlp() to use $PATH */
		/* XXX Allow variable args down the road */
		DEBUG(3, "Running xv -root -quit +nore %s", thisimg);
		execlp(XV_PROGNAME, XV_PROGNAME, "-root", "-quit",
				"+nore", thisimg, NULL);
		/* If we're still here, we're screwed up */
		D_PRINTF("execlp() returned!");
		return(NULL);
	}

	/* NOTREACHED */
	exit(1);
}
