/*
 * bgrotd.h
 * Central header file for bgrot server
 * bgrot project
 * $Fuller: myprograms/bgrot/server/include/bgrotd.h,v 1.24 2004/02/18 12:29:58 fullermd Exp $
 */

#ifndef _BGROTD_H_
#define _BGROTD_H_

/* Definitions */
#define XV_PROGNAME		"xv"
#define XV_WAIT			10 /* Seconds */


/* Might use dmalloc, do this here */
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif


/* Useful macros */
/*
 * NOTE:
 * D_PRINTF() requires C99 compatability (or, alternately, GNU GCC),
 * since it uses variadic macros.
 * We use some tricks to try and be portable, but it's not the best
 * tested.  And if your compiler is non-GNU and non-C99...  well, tough.
 */
#if defined(__GNUC__)
/* Use a backward-GCC-compatible method */
# define D_PRINTF(args...) DEBUG(1, args)
# define DEBUG(lvl, args...) debug_print(lvl, __LINE__, __FILE__, args)
#else
/* Use straight C99 and hope the compiler supports it */
# define D_PRINTF(...) debug(1, __VA_ARGS__)
# define DEBUG(lvl, ...) debug_print(lvl, __LINE__, __FILE__, __VA_ARGS__)
#endif


/* Prototypes */
/* util functions */
int bg_daemon(void);
BGROTD_CONF *gencf(char *);
void usage(void);
void emerg_exit(int);
void debug_print(int, int, const char *, const char *, ...);

/* Threads */
void *show_images_thr(void *);
void *display_image_thr(void *);

#endif /* !_BGROTD_H_ */
