/*
 * emerg_exit.c
 * Emergency exit functionality
 * bgrot project
 * $Fuller: myprograms/bgrot/server/util/emerg_exit.c,v 1.10 2004/02/18 12:35:43 fullermd Exp $
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <bgrot.h>
#include <bgrotd.h>

/* Suck globals */
extern pthread_t img_thr;
extern BGROTD_CONF *runcf;
extern IMGENT **cur_img;
extern IMGENT **nxt_img;


/* Die, sucker */
void
emerg_exit(int signo)
{

	D_PRINTF("Entering exit handler from signal %d", signo);

	/* Kill off the images thread */
	pthread_cancel(img_thr);
	sleep(2); /* A bit of a hack */

	/* Clear out all these variables (probably unnecessary) */
	free_bgrotd_conf(runcf);
	free_imgent(*cur_img);
	free_imgent(*nxt_img);
	free(cur_img);
	free(nxt_img);

	D_PRINTF("Exiting from signal %d", signo);
	exit(1);
}
