/*
 * gencf.c
 * Generate the BGROTD_CONF and its underlings
 * bgrot project
 * $Fuller: myprograms/bgrot/server/util/gencf.c,v 1.2 2003/03/09 13:12:59 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <bgrot.h>
#include <bgrotd.h>


/* Grab our config file */
BGROTD_CONF *
gencf(char *conffile)
{
	BGROTD_CONF *cfret;
	size_t mlen;
	char *idxfile;

	/* Parse out the main conf file */
	cfret = parse_conf(conffile);
	if(cfret==NULL)
	{
		fprintf(stderr, "Failed to parse conf file '%s'!\n", conffile);
		exit(1);
	}

	/* Now parse out the index file */
	/* basedir + '/' + listdir + '/' + "index.xml" + '\0' */
	mlen = strlen(cfret->basedir) + '/' + strlen(cfret->listdir) + 1 + 9 + 1;
	idxfile = malloc(mlen);
	sprintf(idxfile, "%s/%s/index.xml", cfret->basedir, cfret->listdir);
	cfret->list_index = parse_index(idxfile);
	if(cfret->list_index==NULL)
	{
		fprintf(stderr, "Failed to parse index file '%s'!\n", idxfile);
		exit(1);
	}
	free(idxfile);

	return(cfret);
}
