#!/bin/sh -e
# $Fuller: myprograms/bgrot/tools/createlist.sh,v 1.4 2003/03/10 12:36:07 fullermd Exp $

# Simple example script to quickly and easily generate a list of images
# in a given directory, and output it as a properly setup XML file for
# bgrotd.

DIRS=$*
IM_FILES="gif jpg jpeg"

echo '<?xml version="1.0" standalone="no" ?>'
echo '<!DOCTYPE imglist SYSTEM "imglist.dtd">'
echo '<imglist version="1.2">'
echo " <title>Images in ${MWD}</title>"
echo " <longdesc>List of images in ${MWD}</longdesc>"
echo " <conf>"
echo '  <defint defvary="0">30</defint>'
echo "  <defdisp>:0.0</defdisp>"
echo " </conf>"
echo " <images>"
for g in $DIRS; do
	MWD=`cd ${g} && pwd`
	for h in $IM_FILES; do
		for i in `/usr/bin/find ${MWD} -name "*.$h" -print`; do
			echo "  <image file=\"$i\" />"
		done
	done
done
echo " </images>"
echo "</imglist>"
